﻿EnableExplicit

;{ API wrappers }
; get screensaver delay for current user
; RETURN: value in seconds
Procedure.l GetScreenSaverTimeout ()
	Protected Ret.l
		SystemParametersInfo_(#SPI_GETSCREENSAVETIMEOUT, #Null, @Ret, #Null)
	ProcedureReturn Ret 
EndProcedure

; set screensaver delay to value
; RETURN: 1 on success
Procedure.l SetScreenSaverTimeout (Value.l)
  ProcedureReturn SystemParametersInfo_(#SPI_SETSCREENSAVETIMEOUT, Value, #Null, #SPIF_SENDWININICHANGE)
EndProcedure

; screensaver state
; RETURN: 1 If enabled, 0 If disabled
Procedure.l GetScreenSaverActive()
	Protected Ret.l
		SystemParametersInfo_(#SPI_GETSCREENSAVEACTIVE, #Null, @Ret, #Null)
	ProcedureReturn Ret 
EndProcedure

; set screensaver state
; RETURN: 1 on success
Procedure.l SetScreenSaverActive(Value.l)
	ProcedureReturn SystemParametersInfo_(#SPI_SETSCREENSAVEACTIVE, Value, #Null, #SPIF_SENDWININICHANGE)
EndProcedure
;}


;;;;;;;;;;;;;;;;;;;;;;;;;;
#SCR_TIMEOUT 	= 6
#SCR_AREA_Y		= 6
#SCR_INTERVAL	= 1000 ; daemon iteration interval

; Automatically controls screensaver delay And state
Procedure scr_control()
    Protected MouseXY.POINT	: GetCursorPos_(@MouseXY)
    Protected State.l = Bool(MouseXY\y <= #SCR_AREA_Y)
    
	If Not GetScreenSaverActive() = State
		SetScreenSaverActive(State)
	EndIf
	If State And Not GetScreenSaverTimeout() = #SCR_TIMEOUT
		SetScreenSaverTimeOut(#SCR_TIMEOUT)
	EndIf
EndProcedure

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Global EL_STATE.l = 0 ; used to receive ElDiablo state msg (it will become <> 0 if host tell us to perform quit). it is better to keep it read-only here

; Real code start here..
ProcedureDLL EntryPoint()
	Repeat
		scr_control()
			Delay(#SCR_INTERVAL)			
	Until EL_STATE = $FF		; $FF is that quit constant 
	
	SetScreenSaverActive(#False) ; disable screensaver on quit
EndProcedure


; this function has to return adress of variable (long) used by host process to set and monitor DLL state
ProcedureDLL EntryState()
	ProcedureReturn @EL_STATE
EndProcedure

; debug it as exe
CompilerIf #PB_Compiler_Debugger
	EntryPoint()
CompilerEndIf
; IDE Options = PureBasic 5.31 (Windows - x86)
; ExecutableFormat = Shared Dll
; CursorPosition = 60
; FirstLine = 11
; Folding = +-
; EnableUnicode
; Executable = ..\ad_ScreenMaster.dll
; CPU = 1
; CompileSourceDirectory
; EnableCompileCount = 13
; EnableBuildCount = 3